## nwchem 7.3.0

=== cmx/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GXA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

cmake_minimum_required (VERSION 2.8.8)
project (CMX)

option (CMX_RUNTIME, "Protocols using to build CMX" MPI_RMA)
option (USE_MPI_RMA "use MPI RMA protocols for communication" OFF)
option (USE_MPI_PR "use MPI progress ranks for communication" OFF)
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} src-common src-armci)
message (STATUS "CMX_RUNTIME: ${CMX_RUNTIME}")
if (CMX_RUNTIME STREQUAL "MPI_RMA")
  message(STATUS "Found MPI_RMA")
  set (USE_MPI_RMA ON)
elseif (CMX_RUNTIME STREQUAL "MPI_PR")
  message(STATUS "Found MPI_PR")
  set (USE_MPI_PR ON)
else()
  message(STATUS "Found default MPI_RMA")
  set (USE_MPI_RMA ON)
endif ()
message (STATUS "USE_MPI_RMA: ${USE_MPI_RMA}")
message (STATUS "USE_MPI_PR: ${USE_MPI_PR}")
if (USE_MPI_RMA)
  set(CMX_DEVICE
    src-mpi-rma/cmx.c
    src-mpi-rma/groups.c
  )
  set (CMX_NETWORK_MPI_RMA ON)
  include_directories(AFTER src-mpi-rma)
elseif (USE_MPI_PR)
  set(CMX_DEVICE
    src-mpi-pr/cmx.c
    src-mpi-pr/groups.c
    src-mpi-pr/reg_cache.c
  )
  set (CMX_NETWORK_MPI_PR ON)
  include_directories(AFTER src-mpi-pr)
endif()

set(ARMCI_API
  src-armci/armci.c
  src-armci/capi.c
  src-armci/groups.c
  src-armci/iterator.c
  src-armci/message.c
  src-armci/reg_entry.c
)

find_package(MPI)

add_definitions (-DHAVE_CONFIG_H=1)

# -------------------------------------------------------------
# Check for variable sizes, include files and functions
# -------------------------------------------------------------

# check size of different variables
include(CheckTypeSize)
check_type_size("int" CM_SIZEOF_INT)
check_type_size("double" CM_SIZEOF_DOUBLE)
check_type_size("float" CM_SIZEOF_FLOAT)
check_type_size("long" CM_SIZEOF_LONG)
check_type_size("long double" CM_SIZEOF_LONG_DOUBLE)
check_type_size("long long" CM_SIZEOF_LONG_LONG)
check_type_size("short" CM_SIZEOF_SHORT)

# check for standard C/C++ include files
include(CheckIncludeFiles)
check_include_files("assert.h" HAVE_ASSERT_H)
check_include_files("limits.h" HAVE_LIMITS_H)
check_include_files("linux/limits.h" HAVE_LINUX_LIMITS_H)
check_include_files("malloc.h" HAVE_MALLOC_H)
check_include_files("math.h" HAVE_MATH_H)
check_include_files("stddef.h" HAVE_STDDEF_H)
check_include_files("stdint.h" HAVE_STDINT_H)
check_include_files("stdio.h" HAVE_STDIO_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("strings.h" HAVE_STRINGS_H)
check_include_files("string.h" HAVE_STRING_H)
check_include_files("sys/types.h" HAVE_SYS_TYPES_H)
check_include_files("unistd.h" HAVE_UNISTD_H)
check_include_files("windows.h" HAVE_WINDOWS_H)

# check for certain functions
include(CheckFunctionExists)
check_function_exists("bzero" HAVE_BZERO)

# check to see if rt library exists. If so, add -lrt to GA_EXTRA_LIBS
find_library(LIBRT rt PATHS /lib /usr/lib /usr/local/lib)
if (LIBRT)
  message(STATUS "VALUE OF LIBRT: ${LIBRT}")
#  if (CMX_EXTRA_LIBS)
#    set (CMX_EXTRA_LIBS "${CMX_EXTRA_LIBS} rt")
#  else()
#    set (CMX_EXTRA_LIBS rt)
#  endif()
#  set (CMAKE_REQUIRED_LIBRARIES "rt ${CMAKE_REQUIRED_LIBRARIES}")
#  message(STATUS "CMAKE_REQUIRED_LIBRARIES: ${CMAKE_REQUIRED_LIBRARIES}")
  list(APPEND CMX_EXTRA_LIBS rt)
else()
  message(STATUS "NO LIBRT FOUND")
endif()


# -------------------------------------------------------------
# figure out what BLAS library looks like
# -------------------------------------------------------------
if (NOT DEFINED ENABLE_BLAS)
option (ENABLE_BLAS "Include external BLAS" ON)
endif()
INCLUDE( CheckCSourceCompiles )
if (ENABLE_BLAS)
set (CMAKE_REQUIRED_LIBRARIES "blas ${CMAKE_REQUIRED_LIBRARIES}")
CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy (n,c1,ca,1,cb,1);
char daxpy_result = daxpy (n,d1,da,1,db,1);
char saxpy_result = saxpy (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy (n,z1,za,1,zb,1);
char ccopy_result = ccopy (n,c1,ca,1,cb,1);
char dcopy_result = dcopy (n,d1,da,1,db,1);
char scopy_result = scopy (n,s1,sa,1,sb,1);
char zcopy_result = zcopy (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy_ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy_ (n,d1,da,1,db,1);
char saxpy_result = saxpy_ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy_ (n,z1,za,1,zb,1);
char ccopy_result = ccopy_ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy_ (n,d1,da,1,db,1);
char scopy_result = scopy_ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_2_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy__ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy__ (n,d1,da,1,db,1);
char saxpy_result = saxpy__ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy__ (n,z1,za,1,zb,1);
char ccopy_result = ccopy__ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy__ (n,d1,da,1,db,1);
char scopy_result = scopy__ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_3_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY (n,d1,da,1,db,1);
char saxpy_result = SAXPY (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY (n,z1,za,1,zb,1);
char ccopy_result = CCOPY (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY (n,d1,da,1,db,1);
char scopy_result = SCOPY (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_4_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY_ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY_ (n,d1,da,1,db,1);
char saxpy_result = SAXPY_ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY_ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY_ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY_ (n,d1,da,1,db,1);
char scopy_result = SCOPY_ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_5_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY__ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY__ (n,d1,da,1,db,1);
char saxpy_result = SAXPY__ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY__ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY__ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY__ (n,d1,da,1,db,1);
char scopy_result = SCOPY__ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_6_SIGNATURE )
endif()

# set blas symbols
if (BLAS_1_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy)
  set(CM_BLAS_DAXPY daxpy)
  set(CM_BLAS_SAXPY saxpy)
  set(CM_BLAS_ZAXPY zaxpy)
  set(CM_BLAS_CCOPY ccopy)
  set(CM_BLAS_DCOPY dcopy)
  set(CM_BLAS_SCOPY scopy)
  set(CM_BLAS_ZCOPY zcopy)
elseif (BLAS_2_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
elseif (BLAS_3_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy__)
  set(CM_BLAS_DAXPY daxpy__)
  set(CM_BLAS_SAXPY saxpy__)
  set(CM_BLAS_ZAXPY zaxpy__)
  set(CM_BLAS_CCOPY ccopy__)
  set(CM_BLAS_DCOPY dcopy__)
  set(CM_BLAS_SCOPY scopy__)
  set(CM_BLAS_ZCOPY zcopy__)
elseif (BLAS_4_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY)
  set(CM_BLAS_DAXPY DAXPY)
  set(CM_BLAS_SAXPY SAXPY)
  set(CM_BLAS_ZAXPY ZAXPY)
  set(CM_BLAS_CCOPY CCOPY)
  set(CM_BLAS_DCOPY DCOPY)
  set(CM_BLAS_SCOPY SCOPY)
  set(CM_BLAS_ZCOPY ZCOPY)
elseif (BLAS_5_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY_)
  set(CM_BLAS_DAXPY DAXPY_)
  set(CM_BLAS_SAXPY SAXPY_)
  set(CM_BLAS_ZAXPY ZAXPY_)
  set(CM_BLAS_CCOPY CCOPY_)
  set(CM_BLAS_DCOPY DCOPY_)
  set(CM_BLAS_SCOPY SCOPY_)
  set(CM_BLAS_ZCOPY ZCOPY_)
elseif (BLAS_6_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY__)
  set(CM_BLAS_DAXPY DAXPY__)
  set(CM_BLAS_SAXPY SAXPY__)
  set(CM_BLAS_ZAXPY ZAXPY__)
  set(CM_BLAS_CCOPY CCOPY__)
  set(CM_BLAS_DCOPY DCOPY__)
  set(CM_BLAS_SCOPY SCOPY__)
  set(CM_BLAS_ZCOPY ZCOPY__)
else()
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
endif()

# check for weak alias pragma

CHECK_C_SOURCE_COMPILES(
"
extern void weakf(int c);
#pragma weak weakf = __weakf
void __weakf(int c) {}
int main(int argc, char **argv) {
  weakf(0);
  return(0);
}
"
   HAVE_SYS_WEAK_ALIAS_PRAGMA )

# Check for  FUNCTION_NAME

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __func__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __FUNCTION__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_2_SIGNATURE )
if (FUNCTION_1_SIGNATURE)
  set(CM_FUNCTION_NAME __func__)
elseif(FUNCTION_2_SIGNATURE)
  set(CM_FUNCTION_NAME __FUNCTION__)
else()
  set(CM_FUNCTION_NAME __func__)
endif()

# check for availability of some functions
include(CheckFunctionExists)
CHECK_FUNCTION_EXISTS(sched_setaffinity
     HAVE_SCHED_SETAFFINITY)
CHECK_FUNCTION_EXISTS(pthread_setaffinity_np
     HAVE_PTHREAD_SETAFFINITY_NP)



# -------------------------------------------------------------

=== pario/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# PARIO header installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(DRA_FORTRAN_HEADERS
      dra/dra.fh
      dra/draf2c.h)
  set(DRA_FORTRAN_FILES
      dra/fortran.c)
  set(EAF_FORTRAN_HEADERS
      eaf/eaf.fh)
  set(EAF_FORTRAN_FILES
      eaf/eaf_f2c.c)
  set(SF_FORTRAN_HEADERS
      sf/sf.fh
      sf/sff2c.h)
  set(SF_FORTRAN_FILES
      sf/sf_fortran.c)
endif()

set(DRA_HEADERS
  dra/dra.h
#  dra/buffers.h
#  dra/drap.h
  ${DRA_FORTRAN_HEADERS}
)

set(EAF_HEADERS
  eaf/eaf.h
#  eaf/eafP.h
  ${EAF_FORTRAN_HEADERS}
)

set(ELIO_HEADERS
   elio/elio.h
   elio/chemio.h
#   elio/eliop.h
#   elio/pablo.h
)

set(SF_HEADERS
    sf/sf.h
    sf/coms.h
    ${SF_FORTRAN_HEADERS}
)

install (FILES
  ${DRA_HEADERS}
  ${EAF_HEADERS}
  ${ELIO_HEADERS}
  ${SF_HEADERS}
  DESTINATION include/ga
)

list (APPEND GA_HEADER_PATHS 
      ${CMAKE_CURRENT_LIST_DIR}
      ${CMAKE_CURRENT_LIST_DIR}/dra
      ${CMAKE_CURRENT_LIST_DIR}/sf
      ${CMAKE_CURRENT_LIST_DIR}/eaf
      ${CMAKE_CURRENT_LIST_DIR}/elio)

set (GA_HEADER_PATHS ${GA_HEADER_PATHS} PARENT_SCOPE)

# -------------------------------------------------------------
#  PARIO executable files
# -------------------------------------------------------------

set(DRA_FILES
    dra/capi.c
    dra/disk.arrays.c
    dra/disk.param.c
    dra/env.c
    dra/buffers.c
    dra/fortran.c
    # dra/global.unsup.c
    dra/patch.util.c
    # dra/util.c
    ${DRA_FORTRAN_FILES}
)

set(EAF_FILES
    eaf/eaf.c
    eaf/eaf_f2c.c
    ${EAF_FORTRAN_FILES}
)

set(ELIO_FILES
    elio/elio.c
    elio/stat.c
)

set(SF_FILES
     sf/shared.files.c
     sf/sf_capi.c
     sf/sf_fortran.c
     ${SF_FORTRAN_FILES}
)

# -------------------------------------------------------------
# PARIO library installation
# -------------------------------------------------------------

set(PARIO_INC_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${PROJECT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/dra
                    ${CMAKE_CURRENT_SOURCE_DIR}/eaf
                    ${CMAKE_CURRENT_SOURCE_DIR}/elio
                    ${CMAKE_CURRENT_SOURCE_DIR}/sf
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_SOURCE_DIR}/global/src)

add_library(sf OBJECT ${SF_FILES})
add_library(dra OBJECT ${DRA_FILES})
add_library(eaf OBJECT ${EAF_FILES})
add_library(elio OBJECT ${ELIO_FILES})

target_include_directories(sf   BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(dra  BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(eaf  BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(elio BEFORE PRIVATE ${PARIO_INC_DIRS})

if (ENABLE_FORTRAN)
  add_dependencies(sf GenerateConfigFH)
  add_dependencies(dra GenerateConfigFH)
  add_dependencies(eaf GenerateConfigFH)
  add_dependencies(elio GenerateConfigFH)
endif()

=== tools/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# GA tools headers installation
# -------------------------------------------------------------

set(GA_TOOLS_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/ga-wprof.h
)

install(FILES
  ${GA_TOOLS_HEADERS}
  DESTINATION include/ga
)

add_library(ga_tools OBJECT
  ga-wapi.c
  ga-wprof.c
)

list (APPEND GA_HEADER_PATHS ${CMAKE_CURRENT_LIST_DIR})
set (GA_HEADER_PATHS ${GA_HEADER_PATHS} PARENT_SCOPE)

target_include_directories(ga_tools BEFORE PRIVATE
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_BINARY_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/comex/src-armci
                    ${PROJECT_BINARY_DIR})

=== contrib/mov2asc/Makefile ===
# Makefile for movecs <--> ASCII translators
# $Id$

# Tested on KSR, Cray-T3D
# Requires NWCHEM_TARGET to be set.
# Requires NWChem includes and library for MA (in libnwcutil.a)
ifndef NWCHEM_TOP
NWCHEM_TOP= $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST)))| \
 sed -e 's/\/contrib.*//' )
endif
ifndef NWCHEM_TARGET
  UNAME_S := $(shell uname -s)
  ifeq ($(UNAME_S),Linux)
    NWCHEM_TARGET=LINUX64
  else ifeq ($(UNAME_S),Darwin)
    NWCHEM_TARGET=MACX64
  else
error2:
$(info     )
$(info You must define NWCHEM_TARGET in your environment to be the name)
$(info of the machine you wish to build for ... for example)
$(info     setenv NWCHEM_TARGET SOLARIS)
$(info Known targets are SOLARIS, ...)
$(info See the INSTALL instructions for a complete list)
$(error )
  endif
endif

ifeq ($(FC),f77)
  FC=gfortran
endif
ifeq ($(NWCHEM_TARGET),LINUX)
   FFLAGS = -fno-second-underscore
endif
ifeq ($(NWCHEM_TARGET),$(findstring $(NWCHEM_TARGET), LINUX64 MACX64))
  ifeq ($(FC),gfortran)
   FFLAGS = -fdefault-integer-8
  else
   FFLAGS = -i8
#   FFLAGS =
  endif	
endif


ifeq ($(NWCHEM_TARGET),IBM)
   FFLAGS = -qEXTNAME
endif

ifeq ($(NWCHEM_TARGET),IBM)
   CPPFLAGS = -WF,"-I../../src/tools/install/include"		# Needs MA includes
else
   CPPFLAGS = -I../../src/tools/install/include			# Needs MA includes
endif
LDFLAGS = -L../../src/tools/install/lib -lga -larmci	# Needs MA library
ifdef USE_MPI 
#ifeq ($(FC),$(findstring $(FC),mpifrt mpfort mpif77 mpxlf mpif90 ftn))
ifeq ($(FC),$(findstring $(FC), ftn))
  LIBMPI =
  MPI_INCLUDE =
  MPI_LIB =
else
ifndef MPI_INCLUDE
# check if mpif90 is present
         MPIF90YN = $(shell $(NWCHEM_TOP)/src/tools/guess-mpidefs --mpi_include)
  ifeq ($(MPIF90YN),mpif90notfound)
  errormpif90:
	@echo " "
	@echo "mpif90 not found. Please add its location to PATH"
	@echo "e.g. export PATH=/usr/local/bin:/usr/lib64/openmpi/bin:..."
	@echo " "
  endif
        MPI_INCLUDE = $(shell $(NWCHEM_TOP)/src/tools/guess-mpidefs --mpi_include)
endif
ifndef MPI_LIB
        MPI_LIB     = $(shell $(NWCHEM_TOP)/src/tools/guess-mpidefs --mpi_lib)
endif
ifndef LIBMPI
        LIBMPI      = $(shell $(NWCHEM_TOP)/src/tools/guess-mpidefs --libmpi)
endif
endif
ifdef MPI_LIB 
      LDFLAGS += $(patsubst -L-L%,-L%,-L$(MPI_LIB))
endif 
ifdef OLD_GA
  LDFLAGS += -ltcgmsg-mpi $(LIBMPI) 
else
  LDFLAGS += $(LIBMPI)
endif
endif
ifneq ($(USE_GPROF),)
  FFLAGS += -pg
  LDFLAGS += -pg
endif
COMM_LIBS=  $(shell grep ARMCI_NETWORK_LIBS\ = ${NWCHEM_TOP}/src/tools/build/Makefile | cut -b 22-)
LDFLAGS += $(COMM_LIBS)

#ifdef BLASOPT
#  LDFLAGS += $(BLASOPT)
#endif
#ifdef BLAS_LIB
#  LDFLAGS += $(BLAS_LIB)
#endif
#ifdef BUILD_OPENBLAS
#  LDFLAGS += -L$(NWCHEM_TOP)/src/libext/lib -lnwc_openblas -lpthread
#endif
ifneq ("$(wildcard ${NWCHEM_TOP}/src/tools/install/bin/ga-config)","")
  LDFLAGS+=  $(shell ${NWCHEM_TOP}/src/tools/install/bin/ga-config --ldflags  )
  LDFLAGS+=  $(shell ${NWCHEM_TOP}/src/tools/install/bin/ga-config --libs  )
endif

all:    mov2asc asc2mov

mov2asc:	mov2asc.o
	${FC} ${FFLAGS} ${CPPFLAGS} -o $@ $^ ${LDFLAGS} 

asc2mov:	asc2mov.o
	${FC} ${FFLAGS} ${CPPFLAGS} -o $@ $^ ${LDFLAGS} 


clean realclean:
	$(RM) *.o mov2asc asc2mov



%.o:	%.F
	$(FC) -c $(FFLAGS) $(CPPFLAGS) $<

%.o:	%.f
	$(FC) -c $(FFLAGS) $<

%.o:	%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $<

=== global/testing/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE 
  ${PROJECT_SOURCE_DIR}/global/src
  ${PROJECT_BINARY_DIR}/global/src
  ${PROJECT_SOURCE_DIR}/ma 
  ${PROJECT_BINARY_DIR}/ma
  ${PROJECT_BINARY_DIR}/gaf2c
  ${PROJECT_SOURCE_DIR}/comex/src-armci
  # ${PROJECT_SOURCE_DIR}/tcgmsg
  ${PROJECT_SOURCE_DIR}/LinAlg/lapack+blas
  ${PROJECT_SOURCE_DIR}/global/testing
  ${PROJECT_BINARY_DIR})


set(TEST_NPROCS_1 1)
set(TEST_NPROCS_2 2)
if(MPI_PR)
  set(TEST_NPROCS_1 2)
  set(TEST_NPROCS_2 3)
endif()

# -------------------------------------------------------------
# Build test executables
# -------------------------------------------------------------

# This test uses random() and srandom() which are not available on Windows
if(NOT MSVC)
  ga_add_parallel_test (mulmatpatchc "mulmatpatchc.c util.c" ${TEST_NPROCS_1})
endif()

ga_add_parallel_test (elempatch     "elempatch.c util.c" )
ga_add_parallel_test (getmem        "getmem.c util.c"    )
ga_add_parallel_test (mtest         "mtest.c util.c"     )
ga_add_parallel_test (normc         "normc.c util.c"     )
ga_add_parallel_test (matrixc       "matrixc.c"          )
ga_add_parallel_test (ntestc        "ntestc.c"           )
ga_add_parallel_test (nbtestc       "nbtestc.c"          )
ga_add_parallel_test (ntestfc       "ntestfc.c"          )
ga_add_parallel_test (packc         "packc.c util.c"     )
ga_add_parallel_test (print         "print.c util.c"     )
ga_add_parallel_test (scan_addc     "scan_addc.c util.c" )
ga_add_parallel_test (scan_copyc    "scan_copyc.c util.c")
ga_add_parallel_test (testc         "testc.c util.c"     )
ga_add_parallel_test (testmult      "testmult.c util.c"  )
ga_add_parallel_test (testmatmultc  "testmatmultc.c"     )
ga_add_parallel_test (testmultrect  "testmultrect.c"     )
ga_add_parallel_test (gemmtest      "gemmtest.c"         )
ga_add_parallel_test (read_only     "read_only.c"        )
ga_add_parallel_test (cache_test    "cache_test.c"       )
ga_add_parallel_test (unpackc       "unpackc.c util.c"   )
ga_add_parallel_test (perf2         "perf2.c"            )
ga_add_parallel_test (ga-mpi        "ga-mpi.c util.c"    )
ga_add_parallel_test (lock          "lock.c util.c"      )
ga_add_parallel_test (comm_init     "comm_init.c util.c" )

ga_add_parallel_test (patch_enumc         "patch_enumc.c util.c"        )
ga_add_parallel_test (simple_groups_commc "simple_groups_commc.c util.c")
ga_add_parallel_test (thread_perf_contig  "thread_perf_contig.c util.c" )
ga_add_parallel_test (thread_perf_strided "thread_perf_strided.c util.c")
ga_add_parallel_test (threadsafec         "threadsafec.c util.c"        )

if(LAPACK_FOUND)
  ga_add_parallel_test (ga_lu "ga_lu.c util.c")
endif()

if (ENABLE_FORTRAN)
  ga_add_parallel_test (bin            "bin.F ffflush.F"                    Fortran)
  ga_add_parallel_test (blktest        "blktest.F ffflush.F"                Fortran)
  ga_add_parallel_test (g2test         "g2test.F ffflush.F util.c"          Fortran)
  ga_add_parallel_test (g3test         "g3test.F ffflush.F util.c"          Fortran)
  ga_add_parallel_test (ga_shift       "ga_shift.F ffflush.F"               Fortran)
  ga_add_parallel_test (ghosts         "ghosts.F ffflush.F util.c"          Fortran)
  ga_add_parallel_test (jacobi         "jacobi.F ffflush.F"                 Fortran)
  ga_add_parallel_test (mir_perf2      "mir_perf2.F ffflush.F util.c"       Fortran)
  ga_add_parallel_test (mmatrix        "mmatrix.F ffflush.F util.c"         Fortran)
  ga_add_parallel_test (mulmatpatch    "mulmatpatch.F ffflush.F testblas.F" Fortran)
  ga_add_parallel_test (nbtest         "nbtest.F ffflush.F util.c"          Fortran)
  ga_add_parallel_test (nb2test        "nb2test.F ffflush.F util.c"         Fortran)
  ga_add_parallel_test (ndim           "ndim.F ffflush.F util.c"            Fortran)
  ga_add_parallel_test (patch          "patch.F ffflush.F testblas.F"       Fortran)
  ga_add_parallel_test (patch2         "patch2.F ffflush.F"                 Fortran)
  ga_add_parallel_test (patch_enumf    "patch_enumf.F ffflush.F"            Fortran)
  ga_add_parallel_test (perfmod        "perfmod.F ffflush.F util.c"         Fortran)
  ga_add_parallel_test (perform        "perform.F ffflush.F util.c"         Fortran)
  ga_add_parallel_test (perf           "perf.F ffflush.F util.c"            Fortran)
  ga_add_parallel_test (pg2test        "pg2test.F ffflush.F util.c"         Fortran)
  ga_add_parallel_test (pgtest         "pgtest.F ffflush.F util.c"          Fortran)
  ga_add_parallel_test (scan           "scan.F ffflush.F"                   Fortran)

  ga_add_parallel_test (sparse         "sparse.F ffflush.F"             Fortran)
  ga_add_parallel_test (sprsmatmult    "sprsmatmult.F ffflush.F"        Fortran)
  ga_add_parallel_test (stride         "stride.F ffflush.F"             Fortran)
  ga_add_parallel_test (test           "test.F ffflush.F util.c"        Fortran)
  ga_add_parallel_test (testmatmult    "testmatmult.F ffflush.F util.c" Fortran)
  ga_add_parallel_test (testsolve      "testsolve.F ffflush.F"          Fortran)
  ga_add_parallel_test (overlay        "overlay.F ffflush.F util.c"     Fortran)
  ga_add_parallel_test (testeig        "testeig.F ffflush.F"            Fortran)

  ga_add_parallel_test (simple_groups      "simple_groups.F ffflush.F"      Fortran)
  ga_add_parallel_test (simple_groups_comm "simple_groups_comm.F ffflush.F" Fortran)

  # Generated Tests
  function(generate_ngatests testname)
    add_custom_command(
      OUTPUT ${CMAKE_BINARY_DIR}/${testname}.F
      COMMAND ${ga_m4_cmd} ${PROJECT_SOURCE_DIR}/global/testing/${testname}.m4 > ${CMAKE_BINARY_DIR}/${testname}.F
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/global/testing
      COMMENT "Generating ${testname} test"
    )
  endfunction()

  generate_ngatests(nga-onesided)
  generate_ngatests(nga-patch)
  generate_ngatests(nga-periodic)
  generate_ngatests(nga-scatter)
  generate_ngatests(ngatest)
  generate_ngatests(nga-util)

  set (NGATEST_GEN_SRCS
      ${CMAKE_BINARY_DIR}/nga-onesided.F
      ${CMAKE_BINARY_DIR}/nga-patch.F
      ${CMAKE_BINARY_DIR}/nga-periodic.F
      ${CMAKE_BINARY_DIR}/nga-scatter.F
      ${CMAKE_BINARY_DIR}/ngatest.F
      ${CMAKE_BINARY_DIR}/nga-util.F
  )
  add_custom_target(
    GenerateNGATests ALL
    DEPENDS ${NGATEST_GEN_SRCS}
  )
  set_source_files_properties(
    ${NGATEST_GEN_SRCS}
    PROPERTIES GENERATED TRUE
  )

  ga_add_parallel_test (nga-onesided   "${CMAKE_BINARY_DIR}/nga-onesided.F ffflush.F util.c" ${TEST_NPROCS_2} Fortran)
  ga_add_parallel_test (nga-patch      "${CMAKE_BINARY_DIR}/nga-patch.F    ffflush.F util.c" ${TEST_NPROCS_1} Fortran)
  ga_add_parallel_test (nga-periodic   "${CMAKE_BINARY_DIR}/nga-periodic.F ffflush.F util.c"  Fortran                )
  ga_add_parallel_test (nga-scatter    "${CMAKE_BINARY_DIR}/nga-scatter.F  ffflush.F util.c"  Fortran                )
  ga_add_parallel_test (ngatest        "${CMAKE_BINARY_DIR}/ngatest.F      ffflush.F util.c" ${TEST_NPROCS_1} Fortran)
  ga_add_parallel_test (nga-util       "${CMAKE_BINARY_DIR}/nga-util.F     ffflush.F util.c"  Fortran                )

  add_dependencies(nga-onesided.x GenerateNGATests)
  add_dependencies(nga-patch.x    GenerateNGATests)
  add_dependencies(nga-periodic.x GenerateNGATests)
  add_dependencies(nga-scatter.x  GenerateNGATests)
  add_dependencies(ngatest.x      GenerateNGATests)
  add_dependencies(nga-util.x     GenerateNGATests)
  

endif()

=== contrib/marat/amber-helper/Makefile ===
EXE	= amber-helper
SRCS = \
main.F test.F
OBJS =$(SRCS:.f=.o)
${EXE}: $(OBJS) ;
	${FC} -o ${EXE} ${OBJS}

clean:
	rm -f *.o amber-helper

=== contrib/marat/pdb-utils/Makefile ===
#
# Makefile For Response/Local Potential Calculation
#
EXE     = transform_pdb
SRCS = \
main.f smd_pdb.f
OBJS =$(SRCS:.f=.o)
${EXE}: $(OBJS) ;
	${FC} -o ${EXE} ${OBJS}

clean:
	rm -rf *.o transform_pdb

=== src/tce/ttlg/CMakeLists.txt ===
#TODO: Double check the GPU part
INCLUDE(FindCUDA)

if(CUDA_TOOLKIT_INCLUDE) 
    list(APPEND TCE_INCLUDES ${CUDA_TOOLKIT_INCLUDE})
else()
    message(WARNING "CUDA_TOOLKIT_INCLUDE not set.")
endif()

set(TTLG_CUDA_SOURCE_FILES 
fvimatchl32.cu 
fvimatchg32.cu 
fvimatchg32_blocking.cu 
fvinomatchgeneral.cu
fvigeneralolap.cu)


set(TTLG_CPP_SOURCE_FILES 
 model.c
 main.cpp
 Parameters.cpp  
 BlockingCase.cpp 
 ParameterTuner.cpp 
 TransposeSpec.cpp)

set_source_files_properties(${TTLG_CPP_SOURCE_FILES} PROPERTIES CUDA_SOURCE_PROPERTY_FORMAT OBJ)

cuda_add_library(ttlg STATIC ${TTLG_CPP_SOURCE_FILES} ${TTLG_CUDA_SOURCE_FILES})
target_include_directories(ttlg PUBLIC ${PROJECT_SOURCE_DIR}/src/tce/ttlg/includes)
target_compile_options(ttlg PRIVATE -O3 -Xcompiler -fPIC -std=c++11 -DNOHTIME -Xptxas --warn-on-spills -arch=sm_35)

=== src/tce/ttlg/Makefile ===
IFLAGS =  -Iincludes/
ARCH =  -arch=sm_35 
#ARCH = -arch=sm_35
#NVFLAGS = -O3 -std=c++11  -DNOHTIME -arch=sm_35
#NVFLAGS = -O3 -std=c++11 $(IFLAGS)  $(CFLAGS) -DNOHTIME -Xptxas --warn-on-spills -Xptxas -dlcm=ca  $(ARCH)
NVFLAGS = -O3 -Xcompiler -fPIC -std=c++11 $(IFLAGS)  $(CFLAGS) -DNOHTIME -Xptxas --warn-on-spills   $(ARCH)
#NVFLAGS = -O3 -std=c++11  -DNOHTIME  -Xptxas --warn-on-spills -Xptxas -dlcm=cg
#NVFLAGS = -O3 -std=c++11  -DNOHTIME  -Xptxas --warn-on-spills -Xptxas -dlcm=ca -arch=sm_35
#NVFLAGS = -O3 -std=c++11  -DNOHTIME  -Xptxas --warn-on-spills -Xptxas -flcm=ca -arch=sm_35

HEADERS = kernels/fvigeneralolap.h
SCR1 =  fvimatchl32.cu fvimatchg32_blocking.cu \
	fvimatchg32.cu      fvinomatchgeneral.cu fvigeneralolap.cu 
#SCR1 =  matrixtranspose.cu fvimatchl32.cu fvimatchg32l120.cu        fvinomatchalldiff.cu  fvinomatchonerepeat.cu  fvinomatchsisame.cu \
	fvimatchg32.cu  fvimatchl32_factor.cu  fvinomatchg32.cu      fvinomatchrepdiff.cu fvigeneral.cu fvigeneralolap.cu 

SCR2 = test.cpp BlockingCase.cpp  main.cpp  Parameters.cpp  ParameterTuner.cpp  TransposeSpec.cpp model.c
OBJS = $(SCR1:.cu=.o) $(SCR2:.cpp=.o) 

MAIN = ttlg
MAIN_L = libttlg.so

LIBS = -lgomp -lm
all: $(MAIN) 
lib: $(MAIN_L)
exe: $(MAIN)
$(MAIN_L) : $(OBJS)
	nvcc -shared $(NVFLAGS) $^ -o $(MAIN_L) $(LIBS)
$(MAIN) : $(OBJS)
	nvcc $(NVFLAGS) $^ -o $(MAIN) $(LIBS)
    
%.o : %.cpp
	nvcc $(NVFLAGS) -c $< -o $@

%.o : %.cu
	nvcc $(NVFLAGS) -c $< -o $@
fvigeneralolap.cu : kernels/fvigeneralolap.h


clean:
	rm -f *.o $(MAIN) $(MAIN_L)

=== src/nwpw/gw/Transfer/Makefile ===
# Makefile for ersp
FORTRAN = mpif90
#FORTRAN = gfortran
#FLAGS = -O2
#FLAGS =  -fopenmp -g -O3
#FLAGS =  -fopenmp -g -static
FLAGS =  -fopenmp -g
#FLAGS =  -g
SRC1 = rspfn.o mkpol.o testME.o mksecspec.o tetint.o fndgwc.o rdkss.o \
trispline.o spline.o fegrad.o subint.o invertdielf.o \
pspwmatel.o tprojwf.o mkxclda.o mkse.o mkppse.o mksekss.o m_par.o \
par.o mkploss.o mkpwse.o
#BLASDIR = /home/lwcamp/subroutines/Fortran/ATLAS/Build/lib
#LAPACDIR = /home/lwcamp/subroutines/Fortran/ATLAS/Build/lib
#LIBRARIES = -L$(BLASDIR) -lf77blas -latlas -L$(LAPACDIR) -llapack
LIBRARIES = -L/usr/lib64/openmpi/1.4-gcc/lib/
UD = Utilities/
Util = $(UD)linterp.o $(UD)heapsort.o $(UD)grater.o \
$(UD)quadroots.o $(UD)linalg.o $(UD)spherical.o

ersp : $(SRC1) $(Util)
	$(FORTRAN) $(FLAGS) -o ersp $(SRC1) $(Util) $(LIBRARIES)
rspfn.o : rspfn.f90 m_par.o
	$(FORTRAN) $(FLAGS) -c rspfn.f90
mkpol.o : mkpol.f90
	$(FORTRAN) $(FLAGS) -c mkpol.f90
testME.o : testME.f90
	$(FORTRAN) $(FLAGS) -c testME.f90
mksecspec.o : mksecspec.f90
	$(FORTRAN) $(FLAGS) -c mksecspec.f90
mkse.o : mkse.f90
	$(FORTRAN) $(FLAGS) -c mkse.f90
mk3cse.o : mk3cse.f90
	$(FORTRAN) $(FLAGS) -c mk3cse.f90
mkxclda.o : mkxclda.f90
	$(FORTRAN) $(FLAGS) -c mkxclda.f90
mkppse.o : mkppse.f90
	$(FORTRAN) $(FLAGS) -c mkppse.f90
mksekss.o : mksekss.f90
	$(FORTRAN) $(FLAGS) -c mksekss.f90
tetint.o : tetint.f90
	$(FORTRAN) $(FLAGS) -c tetint.f90
fndgwc.o : fndgwc.f90
	$(FORTRAN) $(FLAGS) -c fndgwc.f90
rdkss.o : rdkss.f90
	$(FORTRAN) $(FLAGS) -c rdkss.f90
trispline.o : trispline.f90
	$(FORTRAN) $(FLAGS) -c trispline.f90
spline.o : spline.f90
	$(FORTRAN) $(FLAGS) -c spline.f90
fegrad.o : fegrad.f90
	$(FORTRAN) $(FLAGS) -c fegrad.f90
subint.o : subint.f90
	$(FORTRAN) $(FLAGS) -c subint.f90
invertdielf.o : invertdielf.f90
	$(FORTRAN) $(FLAGS) -c invertdielf.f90
pspwmatel.o : pspwmatel.f90
	$(FORTRAN) $(FLAGS) -c pspwmatel.f90
tprojwf.o : tprojwf.f90
	$(FORTRAN) $(FLAGS) -c tprojwf.f90
par.o : par.f90
	$(FORTRAN) $(FLAGS) -c par.f90
m_par.o : m_par.f90
	$(FORTRAN) $(FLAGS) -c m_par.f90
mkploss.o : mkploss.f90
	$(FORTRAN) $(FLAGS) -c mkploss.f90
mkpwse.o : mkpwse.f90
	$(FORTRAN) $(FLAGS) -c mkpwse.f90
$(UD)linterp.o : $(UD)linterp.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c linterp.f90
$(UD)heapsort.o : $(UD)heapsort.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c heapsort.f90
$(UD)grater.o : $(UD)grater.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c grater.f90
$(UD)quadroots.o : $(UD)quadroots.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c quadroots.f90
$(UD)linalg.o : $(UD)linalg.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c linalg.f90
$(UD)spherical.o : $(UD)spherical.f90
	cd $(UD); $(FORTRAN) $(FLAGS) -c spherical.f90
clean	:
	rm -f *.o $(Util) *.mod

=== debian/changelog ===
nwchem (7.3.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1111575.
    - applies debian patch 32bit_overflow_n2_ccsd_2824153.patch
    - supports gcc-15 (C23 standard). Closes: #1097484.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Oct 2025 00:01:46 +0100

nwchem (7.2.3-10) unstable; urgency=medium

  * rebuild against ga (libglobalarrays-dev) 5.9.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 May 2025 22:07:59 +0200

nwchem (7.2.3-9) unstable; urgency=medium

  * ensure nwchem is rebuilt for the version of mpich (really4.2.1)
    targetted for trixie

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 May 2025 03:41:12 +0200

nwchem (7.2.3-8) unstable; urgency=medium

  * rebuild against libglobalarrays-dev 5.9.1
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 18 Apr 2025 20:49:20 +0200

=== debian/control ===
Source: nwchem
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
 Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               gfortran,
               bc,
               libarmci-mpi-dev (>= 0.3.1~beta-2~),
               libblas-dev,
               libglobalarrays-dev (>= 5.8.1-4~),
               liblapack-dev,
               libscalapack-mpi-dev (>= 2),
               libscalapack-mpich-dev (>= 2),
               libscalapack-openmpi-dev (>= 2) [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
               mpi-default-bin,
               mpi-default-dev,
               libmpich-dev,
               libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
               openssh-client,
               pkgconf,
               python3-dev,
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://nwchemgit.github.io
Vcs-Browser: https://salsa.debian.org/debichem-team/nwchem
Vcs-Git: https://salsa.debian.org/debichem-team/nwchem.git

Package: nwchem
Architecture: all
Depends: ${nwchem:Depends},
         mpi-default-bin,
         ${misc:Depends}
Description: High-performance computational chemistry software (default MPI)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides example input scripts and depends on nwchem built for
 the default MPI implementation for the architecture.
 .
 The default MPI is openmpi for most 64-bit debian systems. OpenMPI has known
 problems running nwchem over multiple nodes. If you need to compute large
 molecules using cluster computation, you may want to use the MPICH build
 provided by nwchem-mpich instead. 32-bit arches use mpich only.

Package: nwchem-openmpi
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: allowed
Depends: openmpi-bin,
         nwchem-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nwchem (<< 7.2.3-4)
Breaks:   nwchem (<< 7.2.3-4)
Description: High-performance computational chemistry software (OpenMPI build)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides nwchem built with OpenMPI.
 .
 OpenMPI has known problems running nwchem over multiple nodes. If you need
 to compute large molecules using cluster computation, you may want to use
 the MPICH build provided by nwchem-mpich instead.

Package: nwchem-mpich
Architecture: any
Multi-Arch: allowed

=== debian/tests/control ===
Depends: nwchem,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite.sh
Restrictions: allow-stderr

Depends: nwchem-openmpi,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-openmpi
Architecture: !armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32
Restrictions: allow-stderr

Depends: nwchem-mpich,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-mpich
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/nwchemgit/nwchem/releases \
 (?:.*?/)?nwchem-@ANY_VERSION@-release.*-src\..*@ARCHIVE_EXT@
